/* ***********************************************************
 * This file was automatically generated on 2018-11-08.      *
 *                                                           *
 * Rust Bindings Version 2.0.3                               *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

//! 7.1cm (2.8") display with 128x64 pixel and touch screen
use crate::{
    byte_converter::*,
    converting_callback_receiver::ConvertingCallbackReceiver,
    converting_receiver::{BrickletError, BrickletRecvTimeoutError, ConvertingReceiver},
    device::*,
    ip_connection::IpConnection,
    low_level_traits::*,
};
pub enum Lcd128x64BrickletFunction {
    WritePixelsLowLevel,
    ReadPixelsLowLevel,
    ClearDisplay,
    SetDisplayConfiguration,
    GetDisplayConfiguration,
    WriteLine,
    DrawBufferedFrame,
    GetTouchPosition,
    SetTouchPositionCallbackConfiguration,
    GetTouchPositionCallbackConfiguration,
    GetTouchGesture,
    SetTouchGestureCallbackConfiguration,
    GetTouchGestureCallbackConfiguration,
    GetSpitfpErrorCount,
    SetBootloaderMode,
    GetBootloaderMode,
    SetWriteFirmwarePointer,
    WriteFirmware,
    SetStatusLedConfig,
    GetStatusLedConfig,
    GetChipTemperature,
    Reset,
    WriteUid,
    ReadUid,
    GetIdentity,
    CallbackTouchPosition,
    CallbackTouchGesture,
}
impl From<Lcd128x64BrickletFunction> for u8 {
    fn from(fun: Lcd128x64BrickletFunction) -> Self {
        match fun {
            Lcd128x64BrickletFunction::WritePixelsLowLevel => 1,
            Lcd128x64BrickletFunction::ReadPixelsLowLevel => 2,
            Lcd128x64BrickletFunction::ClearDisplay => 3,
            Lcd128x64BrickletFunction::SetDisplayConfiguration => 4,
            Lcd128x64BrickletFunction::GetDisplayConfiguration => 5,
            Lcd128x64BrickletFunction::WriteLine => 6,
            Lcd128x64BrickletFunction::DrawBufferedFrame => 7,
            Lcd128x64BrickletFunction::GetTouchPosition => 8,
            Lcd128x64BrickletFunction::SetTouchPositionCallbackConfiguration => 9,
            Lcd128x64BrickletFunction::GetTouchPositionCallbackConfiguration => 10,
            Lcd128x64BrickletFunction::GetTouchGesture => 12,
            Lcd128x64BrickletFunction::SetTouchGestureCallbackConfiguration => 13,
            Lcd128x64BrickletFunction::GetTouchGestureCallbackConfiguration => 14,
            Lcd128x64BrickletFunction::GetSpitfpErrorCount => 234,
            Lcd128x64BrickletFunction::SetBootloaderMode => 235,
            Lcd128x64BrickletFunction::GetBootloaderMode => 236,
            Lcd128x64BrickletFunction::SetWriteFirmwarePointer => 237,
            Lcd128x64BrickletFunction::WriteFirmware => 238,
            Lcd128x64BrickletFunction::SetStatusLedConfig => 239,
            Lcd128x64BrickletFunction::GetStatusLedConfig => 240,
            Lcd128x64BrickletFunction::GetChipTemperature => 242,
            Lcd128x64BrickletFunction::Reset => 243,
            Lcd128x64BrickletFunction::WriteUid => 248,
            Lcd128x64BrickletFunction::ReadUid => 249,
            Lcd128x64BrickletFunction::GetIdentity => 255,
            Lcd128x64BrickletFunction::CallbackTouchPosition => 11,
            Lcd128x64BrickletFunction::CallbackTouchGesture => 15,
        }
    }
}
pub const LCD_128X64_BRICKLET_GESTURE_LEFT_TO_RIGHT: u8 = 0;
pub const LCD_128X64_BRICKLET_GESTURE_RIGHT_TO_LEFT: u8 = 1;
pub const LCD_128X64_BRICKLET_GESTURE_TOP_TO_BOTTOM: u8 = 2;
pub const LCD_128X64_BRICKLET_GESTURE_BOTTOM_TO_TOP: u8 = 3;
pub const LCD_128X64_BRICKLET_BOOTLOADER_MODE_BOOTLOADER: u8 = 0;
pub const LCD_128X64_BRICKLET_BOOTLOADER_MODE_FIRMWARE: u8 = 1;
pub const LCD_128X64_BRICKLET_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT: u8 = 2;
pub const LCD_128X64_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT: u8 = 3;
pub const LCD_128X64_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT: u8 = 4;
pub const LCD_128X64_BRICKLET_BOOTLOADER_STATUS_OK: u8 = 0;
pub const LCD_128X64_BRICKLET_BOOTLOADER_STATUS_INVALID_MODE: u8 = 1;
pub const LCD_128X64_BRICKLET_BOOTLOADER_STATUS_NO_CHANGE: u8 = 2;
pub const LCD_128X64_BRICKLET_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT: u8 = 3;
pub const LCD_128X64_BRICKLET_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT: u8 = 4;
pub const LCD_128X64_BRICKLET_BOOTLOADER_STATUS_CRC_MISMATCH: u8 = 5;
pub const LCD_128X64_BRICKLET_STATUS_LED_CONFIG_OFF: u8 = 0;
pub const LCD_128X64_BRICKLET_STATUS_LED_CONFIG_ON: u8 = 1;
pub const LCD_128X64_BRICKLET_STATUS_LED_CONFIG_SHOW_HEARTBEAT: u8 = 2;
pub const LCD_128X64_BRICKLET_STATUS_LED_CONFIG_SHOW_STATUS: u8 = 3;

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct WritePixelsLowLevel {}
impl FromByteSlice for WritePixelsLowLevel {
    fn bytes_expected() -> usize { 0 }
    fn from_le_bytes(_bytes: &[u8]) -> WritePixelsLowLevel { WritePixelsLowLevel {} }
}
impl LowLevelWrite<WritePixelsResult> for WritePixelsLowLevel {
    fn ll_message_written(&self) -> usize { 448 }

    fn get_result(&self) -> WritePixelsResult { WritePixelsResult {} }
}

#[derive(Clone, Copy)]
pub struct ReadPixelsLowLevel {
    pub pixels_length: u16,
    pub pixels_chunk_offset: u16,
    pub pixels_chunk_data: [bool; 480],
}
impl FromByteSlice for ReadPixelsLowLevel {
    fn bytes_expected() -> usize { 64 }
    fn from_le_bytes(bytes: &[u8]) -> ReadPixelsLowLevel {
        ReadPixelsLowLevel {
            pixels_length: <u16>::from_le_bytes(&bytes[0..2]),
            pixels_chunk_offset: <u16>::from_le_bytes(&bytes[2..4]),
            pixels_chunk_data: <[bool; 480]>::from_le_bytes(&bytes[4..64]),
        }
    }
}
impl LowLevelRead<bool, ReadPixelsResult> for ReadPixelsLowLevel {
    fn ll_message_length(&self) -> usize { self.pixels_length as usize }

    fn ll_message_chunk_offset(&self) -> usize { self.pixels_chunk_offset as usize }

    fn ll_message_chunk_data(&self) -> &[bool] { &self.pixels_chunk_data }

    fn get_result(&self) -> ReadPixelsResult { ReadPixelsResult {} }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct DisplayConfiguration {
    pub contrast: u8,
    pub backlight: u8,
    pub invert: bool,
    pub automatic_draw: bool,
}
impl FromByteSlice for DisplayConfiguration {
    fn bytes_expected() -> usize { 4 }
    fn from_le_bytes(bytes: &[u8]) -> DisplayConfiguration {
        DisplayConfiguration {
            contrast: <u8>::from_le_bytes(&bytes[0..1]),
            backlight: <u8>::from_le_bytes(&bytes[1..2]),
            invert: <bool>::from_le_bytes(&bytes[2..3]),
            automatic_draw: <bool>::from_le_bytes(&bytes[3..4]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct TouchPosition {
    pub pressure: u16,
    pub x: u16,
    pub y: u16,
    pub age: u32,
}
impl FromByteSlice for TouchPosition {
    fn bytes_expected() -> usize { 10 }
    fn from_le_bytes(bytes: &[u8]) -> TouchPosition {
        TouchPosition {
            pressure: <u16>::from_le_bytes(&bytes[0..2]),
            x: <u16>::from_le_bytes(&bytes[2..4]),
            y: <u16>::from_le_bytes(&bytes[4..6]),
            age: <u32>::from_le_bytes(&bytes[6..10]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct TouchPositionCallbackConfiguration {
    pub period: u32,
    pub value_has_to_change: bool,
}
impl FromByteSlice for TouchPositionCallbackConfiguration {
    fn bytes_expected() -> usize { 5 }
    fn from_le_bytes(bytes: &[u8]) -> TouchPositionCallbackConfiguration {
        TouchPositionCallbackConfiguration {
            period: <u32>::from_le_bytes(&bytes[0..4]),
            value_has_to_change: <bool>::from_le_bytes(&bytes[4..5]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct TouchPositionEvent {
    pub pressure: u16,
    pub x: u16,
    pub y: u16,
    pub age: u32,
}
impl FromByteSlice for TouchPositionEvent {
    fn bytes_expected() -> usize { 10 }
    fn from_le_bytes(bytes: &[u8]) -> TouchPositionEvent {
        TouchPositionEvent {
            pressure: <u16>::from_le_bytes(&bytes[0..2]),
            x: <u16>::from_le_bytes(&bytes[2..4]),
            y: <u16>::from_le_bytes(&bytes[4..6]),
            age: <u32>::from_le_bytes(&bytes[6..10]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct TouchGesture {
    pub gesture: u8,
    pub duration: u32,
    pub pressure_max: u16,
    pub x_start: u16,
    pub y_start: u16,
    pub x_end: u16,
    pub y_end: u16,
    pub age: u32,
}
impl FromByteSlice for TouchGesture {
    fn bytes_expected() -> usize { 19 }
    fn from_le_bytes(bytes: &[u8]) -> TouchGesture {
        TouchGesture {
            gesture: <u8>::from_le_bytes(&bytes[0..1]),
            duration: <u32>::from_le_bytes(&bytes[1..5]),
            pressure_max: <u16>::from_le_bytes(&bytes[5..7]),
            x_start: <u16>::from_le_bytes(&bytes[7..9]),
            y_start: <u16>::from_le_bytes(&bytes[9..11]),
            x_end: <u16>::from_le_bytes(&bytes[11..13]),
            y_end: <u16>::from_le_bytes(&bytes[13..15]),
            age: <u32>::from_le_bytes(&bytes[15..19]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct TouchGestureCallbackConfiguration {
    pub period: u32,
    pub value_has_to_change: bool,
}
impl FromByteSlice for TouchGestureCallbackConfiguration {
    fn bytes_expected() -> usize { 5 }
    fn from_le_bytes(bytes: &[u8]) -> TouchGestureCallbackConfiguration {
        TouchGestureCallbackConfiguration {
            period: <u32>::from_le_bytes(&bytes[0..4]),
            value_has_to_change: <bool>::from_le_bytes(&bytes[4..5]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct TouchGestureEvent {
    pub gesture: u8,
    pub duration: u32,
    pub pressure_max: u16,
    pub x_start: u16,
    pub y_start: u16,
    pub x_end: u16,
    pub y_end: u16,
    pub age: u32,
}
impl FromByteSlice for TouchGestureEvent {
    fn bytes_expected() -> usize { 19 }
    fn from_le_bytes(bytes: &[u8]) -> TouchGestureEvent {
        TouchGestureEvent {
            gesture: <u8>::from_le_bytes(&bytes[0..1]),
            duration: <u32>::from_le_bytes(&bytes[1..5]),
            pressure_max: <u16>::from_le_bytes(&bytes[5..7]),
            x_start: <u16>::from_le_bytes(&bytes[7..9]),
            y_start: <u16>::from_le_bytes(&bytes[9..11]),
            x_end: <u16>::from_le_bytes(&bytes[11..13]),
            y_end: <u16>::from_le_bytes(&bytes[13..15]),
            age: <u32>::from_le_bytes(&bytes[15..19]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct SpitfpErrorCount {
    pub error_count_ack_checksum: u32,
    pub error_count_message_checksum: u32,
    pub error_count_frame: u32,
    pub error_count_overflow: u32,
}
impl FromByteSlice for SpitfpErrorCount {
    fn bytes_expected() -> usize { 16 }
    fn from_le_bytes(bytes: &[u8]) -> SpitfpErrorCount {
        SpitfpErrorCount {
            error_count_ack_checksum: <u32>::from_le_bytes(&bytes[0..4]),
            error_count_message_checksum: <u32>::from_le_bytes(&bytes[4..8]),
            error_count_frame: <u32>::from_le_bytes(&bytes[8..12]),
            error_count_overflow: <u32>::from_le_bytes(&bytes[12..16]),
        }
    }
}

#[derive(Clone, Debug, Default, PartialEq, Eq, Hash)]
pub struct Identity {
    pub uid: String,
    pub connected_uid: String,
    pub position: char,
    pub hardware_version: [u8; 3],
    pub firmware_version: [u8; 3],
    pub device_identifier: u16,
}
impl FromByteSlice for Identity {
    fn bytes_expected() -> usize { 25 }
    fn from_le_bytes(bytes: &[u8]) -> Identity {
        Identity {
            uid: <String>::from_le_bytes(&bytes[0..8]),
            connected_uid: <String>::from_le_bytes(&bytes[8..16]),
            position: <char>::from_le_bytes(&bytes[16..17]),
            hardware_version: <[u8; 3]>::from_le_bytes(&bytes[17..20]),
            firmware_version: <[u8; 3]>::from_le_bytes(&bytes[20..23]),
            device_identifier: <u16>::from_le_bytes(&bytes[23..25]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct WritePixelsResult {}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct ReadPixelsResult {}

/// 7.1cm (2.8") display with 128x64 pixel and touch screen
#[derive(Clone)]
pub struct Lcd128x64Bricklet {
    device: Device,
}
impl Lcd128x64Bricklet {
    pub const DEVICE_IDENTIFIER: u16 = 298;
    pub const DEVICE_DISPLAY_NAME: &'static str = "LCD 128x64 Bricklet";
    /// Creates an object with the unique device ID `uid`. This object can then be used after the IP Connection `ip_connection` is connected.
    pub fn new(uid: &str, ip_connection: &IpConnection) -> Lcd128x64Bricklet {
        let mut result = Lcd128x64Bricklet { device: Device::new([2, 0, 0], uid, ip_connection, 2) };
        result.device.response_expected[u8::from(Lcd128x64BrickletFunction::WritePixelsLowLevel) as usize] = ResponseExpectedFlag::True;
        result.device.response_expected[u8::from(Lcd128x64BrickletFunction::ReadPixelsLowLevel) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(Lcd128x64BrickletFunction::ClearDisplay) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(Lcd128x64BrickletFunction::SetDisplayConfiguration) as usize] =
            ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(Lcd128x64BrickletFunction::GetDisplayConfiguration) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(Lcd128x64BrickletFunction::WriteLine) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(Lcd128x64BrickletFunction::DrawBufferedFrame) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(Lcd128x64BrickletFunction::GetTouchPosition) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(Lcd128x64BrickletFunction::SetTouchPositionCallbackConfiguration) as usize] =
            ResponseExpectedFlag::True;
        result.device.response_expected[u8::from(Lcd128x64BrickletFunction::GetTouchPositionCallbackConfiguration) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(Lcd128x64BrickletFunction::GetTouchGesture) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(Lcd128x64BrickletFunction::SetTouchGestureCallbackConfiguration) as usize] =
            ResponseExpectedFlag::True;
        result.device.response_expected[u8::from(Lcd128x64BrickletFunction::GetTouchGestureCallbackConfiguration) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(Lcd128x64BrickletFunction::GetSpitfpErrorCount) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(Lcd128x64BrickletFunction::SetBootloaderMode) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(Lcd128x64BrickletFunction::GetBootloaderMode) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(Lcd128x64BrickletFunction::SetWriteFirmwarePointer) as usize] =
            ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(Lcd128x64BrickletFunction::WriteFirmware) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(Lcd128x64BrickletFunction::SetStatusLedConfig) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(Lcd128x64BrickletFunction::GetStatusLedConfig) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(Lcd128x64BrickletFunction::GetChipTemperature) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(Lcd128x64BrickletFunction::Reset) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(Lcd128x64BrickletFunction::WriteUid) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(Lcd128x64BrickletFunction::ReadUid) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(Lcd128x64BrickletFunction::GetIdentity) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result
    }

    /// Returns the response expected flag for the function specified by the function ID parameter.
    /// It is true if the function is expected to send a response, false otherwise.
    ///
    /// For getter functions this is enabled by default and cannot be disabled, because those
    /// functions will always send a response. For callback configuration functions it is enabled
    /// by default too, but can be disabled by [`set_response_expected`](crate::lcd_128x64_bricklet::Lcd128x64Bricklet::set_response_expected).
    /// For setter functions it is disabled by default and can be enabled.
    ///
    /// Enabling the response expected flag for a setter function allows to detect timeouts
    /// and other error conditions calls of this setter as well. The device will then send a response
    /// for this purpose. If this flag is disabled for a setter function then no response is send
    /// and errors are silently ignored, because they cannot be detected.
    ///
    /// See [`set_response_expected`](crate::lcd_128x64_bricklet::Lcd128x64Bricklet::set_response_expected) for the list of function ID constants available for this function.
    pub fn get_response_expected(&mut self, fun: Lcd128x64BrickletFunction) -> Result<bool, GetResponseExpectedError> {
        self.device.get_response_expected(u8::from(fun))
    }

    /// Changes the response expected flag of the function specified by the function ID parameter.
    /// This flag can only be changed for setter (default value: false) and callback configuration
    /// functions (default value: true). For getter functions it is always enabled.
    ///
    /// Enabling the response expected flag for a setter function allows to detect timeouts and
    /// other error conditions calls of this setter as well. The device will then send a response
    /// for this purpose. If this flag is disabled for a setter function then no response is send
    /// and errors are silently ignored, because they cannot be detected.
    pub fn set_response_expected(
        &mut self,
        fun: Lcd128x64BrickletFunction,
        response_expected: bool,
    ) -> Result<(), SetResponseExpectedError> {
        self.device.set_response_expected(u8::from(fun), response_expected)
    }

    /// Changes the response expected flag for all setter and callback configuration functions of this device at once.
    pub fn set_response_expected_all(&mut self, response_expected: bool) { self.device.set_response_expected_all(response_expected) }

    /// This receiver is triggered periodically with the period that is set by
    /// `Set Touch Position Receiver Configuration`. The parameters are the
    /// same as for `Get Touch Position`.
    pub fn get_touch_position_callback_receiver(&self) -> ConvertingCallbackReceiver<TouchPositionEvent> {
        self.device.get_callback_receiver(u8::from(Lcd128x64BrickletFunction::CallbackTouchPosition))
    }

    /// This receiver is triggered periodically with the period that is set by
    /// `Set Touch Gesture Receiver Configuration`. The parameters are the
    /// same as for `Get Touch Gesture`.
    pub fn get_touch_gesture_callback_receiver(&self) -> ConvertingCallbackReceiver<TouchGestureEvent> {
        self.device.get_callback_receiver(u8::from(Lcd128x64BrickletFunction::CallbackTouchGesture))
    }

    /// Writes pixels to the specified window.
    ///
    /// The x-axis goes from 0 to 127 and the y-axis from 0 to 63. The pixels are written
    /// into the window line by line top to bottom and each line is written from left to
    /// right.
    ///
    /// If automatic draw is enabled (default) the pixels are directly written to
    /// the screen. Only pixels that have actually changed are updated on the screen,
    /// the rest stays the same.
    ///
    /// If automatic draw is disabled the pixels are written to an internal buffer and
    /// the buffer is transferred to the display only after `Draw Buffered Frame`
    /// is called. This can be used to avoid flicker when drawing a complex frame in
    /// multiple steps.
    ///
    /// Automatic draw can be configured with the `Set Display Configuration`
    /// function.
    pub fn write_pixels_low_level(
        &self,
        x_start: u8,
        y_start: u8,
        x_end: u8,
        y_end: u8,
        pixels_length: u16,
        pixels_chunk_offset: u16,
        pixels_chunk_data: [bool; 448],
    ) -> ConvertingReceiver<WritePixelsLowLevel> {
        let mut payload = vec![0; 64];
        payload[0..1].copy_from_slice(&<u8>::to_le_bytes(x_start));
        payload[1..2].copy_from_slice(&<u8>::to_le_bytes(y_start));
        payload[2..3].copy_from_slice(&<u8>::to_le_bytes(x_end));
        payload[3..4].copy_from_slice(&<u8>::to_le_bytes(y_end));
        payload[4..6].copy_from_slice(&<u16>::to_le_bytes(pixels_length));
        payload[6..8].copy_from_slice(&<u16>::to_le_bytes(pixels_chunk_offset));
        payload[8..64].copy_from_slice(&<[bool; 448]>::to_le_bytes(pixels_chunk_data));

        self.device.set(u8::from(Lcd128x64BrickletFunction::WritePixelsLowLevel), payload)
    }

    /// Writes pixels to the specified window.
    ///
    /// The x-axis goes from 0 to 127 and the y-axis from 0 to 63. The pixels are written
    /// into the window line by line top to bottom and each line is written from left to
    /// right.
    ///
    /// If automatic draw is enabled (default) the pixels are directly written to
    /// the screen. Only pixels that have actually changed are updated on the screen,
    /// the rest stays the same.
    ///
    /// If automatic draw is disabled the pixels are written to an internal buffer and
    /// the buffer is transferred to the display only after `Draw Buffered Frame`
    /// is called. This can be used to avoid flicker when drawing a complex frame in
    /// multiple steps.
    ///
    /// Automatic draw can be configured with the `Set Display Configuration`
    /// function.
    pub fn write_pixels(&self, x_start: u8, y_start: u8, x_end: u8, y_end: u8, pixels: &[bool]) -> Result<(), BrickletRecvTimeoutError> {
        let _ll_result = self.device.set_high_level(0, pixels, 65535, 448, &mut |length: usize, chunk_offset: usize, chunk: &[bool]| {
            let chunk_length = chunk.len() as u16;
            let mut chunk_array = [<bool>::default(); 448];
            chunk_array[0..chunk_length as usize].copy_from_slice(&chunk);

            let result =
                self.write_pixels_low_level(x_start, y_start, x_end, y_end, length as u16, chunk_offset as u16, chunk_array).recv();
            if let Err(BrickletRecvTimeoutError::SuccessButResponseExpectedIsDisabled) = result {
                Ok(Default::default())
            } else {
                result
            }
        })?;
        Ok(())
    }

    /// Reads pixels from the specified window.
    ///
    /// The x-axis goes from 0 to 127 and the y-axis from 0 to 63. The pixels are read
    /// from the window line by line top to bottom and each line is read from left to
    /// right.
    ///
    /// If automatic draw is enabled (default) the pixels that are read are always the
    /// same that are shown on the display.
    ///
    /// If automatic draw is disabled the pixels are read from the internal buffer
    /// (see `Draw Buffered Frame`).
    ///
    /// Automatic draw can be configured with the `Set Display Configuration`
    /// function.
    pub fn read_pixels_low_level(&self, x_start: u8, y_start: u8, x_end: u8, y_end: u8) -> ConvertingReceiver<ReadPixelsLowLevel> {
        let mut payload = vec![0; 4];
        payload[0..1].copy_from_slice(&<u8>::to_le_bytes(x_start));
        payload[1..2].copy_from_slice(&<u8>::to_le_bytes(y_start));
        payload[2..3].copy_from_slice(&<u8>::to_le_bytes(x_end));
        payload[3..4].copy_from_slice(&<u8>::to_le_bytes(y_end));

        self.device.get(u8::from(Lcd128x64BrickletFunction::ReadPixelsLowLevel), payload)
    }

    /// Reads pixels from the specified window.
    ///
    /// The x-axis goes from 0 to 127 and the y-axis from 0 to 63. The pixels are read
    /// from the window line by line top to bottom and each line is read from left to
    /// right.
    ///
    /// If automatic draw is enabled (default) the pixels that are read are always the
    /// same that are shown on the display.
    ///
    /// If automatic draw is disabled the pixels are read from the internal buffer
    /// (see `Draw Buffered Frame`).
    ///
    /// Automatic draw can be configured with the `Set Display Configuration`
    /// function.
    pub fn read_pixels(&self, x_start: u8, y_start: u8, x_end: u8, y_end: u8) -> Result<Vec<bool>, BrickletRecvTimeoutError> {
        let ll_result = self.device.get_high_level(1, &mut || self.read_pixels_low_level(x_start, y_start, x_end, y_end).recv())?;
        Ok(ll_result.0)
    }

    /// Clears the complete content of the display.
    pub fn clear_display(&self) -> ConvertingReceiver<()> {
        let payload = vec![0; 0];

        self.device.set(u8::from(Lcd128x64BrickletFunction::ClearDisplay), payload)
    }

    /// Sets the configuration of the display.
    ///
    /// You can set a contrast value from 0 to 63, a backlight intensity value
    /// from 0 to 100 and you can invert the color (white/black) of the display.
    ///
    /// If automatic draw is set to *true*, the display is automatically updated with every
    /// call of `Write Pixels` and `Write Line`. If it is set to false, the
    /// changes are written into an internal buffer and only shown on the display after
    /// a call of `Draw Buffered Frame`.
    ///
    /// The default values are contrast 14, backlight intensity 100, inverting off
    /// and automatic draw on.
    pub fn set_display_configuration(&self, contrast: u8, backlight: u8, invert: bool, automatic_draw: bool) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 4];
        payload[0..1].copy_from_slice(&<u8>::to_le_bytes(contrast));
        payload[1..2].copy_from_slice(&<u8>::to_le_bytes(backlight));
        payload[2..3].copy_from_slice(&<bool>::to_le_bytes(invert));
        payload[3..4].copy_from_slice(&<bool>::to_le_bytes(automatic_draw));

        self.device.set(u8::from(Lcd128x64BrickletFunction::SetDisplayConfiguration), payload)
    }

    /// Returns the configuration as set by `Set Display Configuration`.
    pub fn get_display_configuration(&self) -> ConvertingReceiver<DisplayConfiguration> {
        let payload = vec![0; 0];

        self.device.get(u8::from(Lcd128x64BrickletFunction::GetDisplayConfiguration), payload)
    }

    /// Writes text to a specific line (0 to 7) with a specific position
    /// (0 to 21). The text can have a maximum of 22 characters.
    ///
    /// For example: (1, 10, Hello) will write *Hello* in the middle of the
    /// second line of the display.
    ///
    /// The display uses a special 5x7 pixel charset. You can view the characters
    /// of the charset in Brick Viewer.
    pub fn write_line(&self, line: u8, position: u8, text: String) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 24];
        payload[0..1].copy_from_slice(&<u8>::to_le_bytes(line));
        payload[1..2].copy_from_slice(&<u8>::to_le_bytes(position));
        match <String>::try_to_le_bytes(text, 22) {
            Err(e) => {
                let (tx, rx) = std::sync::mpsc::channel::<Result<Vec<u8>, BrickletError>>();
                let _ = tx.send(Err(e));
                return ConvertingReceiver::new(rx, std::time::Duration::new(1, 0));
            }
            Ok(bytes) => payload[2..24].copy_from_slice(&bytes),
        }

        self.device.set(u8::from(Lcd128x64BrickletFunction::WriteLine), payload)
    }

    /// Draws the currently buffered frame. Normally each call of `Write Pixels` and
    /// `Write Line` draws directly onto the display. If you turn automatic draw off
    /// (`Set Display Configuration`), the data is written in an internal buffer and
    /// only transferred to the display by calling this function. This can be used to
    /// avoid flicker when drawing a complex frame in multiple steps.
    ///
    /// Set the `force complete redraw` to *true* to redraw the whole display
    /// instead of only the changed parts. Normally it should not be necessary to set this to
    /// *true*. It may only become necessary in case of stuck pixels because of errors.
    pub fn draw_buffered_frame(&self, force_complete_redraw: bool) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 1];
        payload[0..1].copy_from_slice(&<bool>::to_le_bytes(force_complete_redraw));

        self.device.set(u8::from(Lcd128x64BrickletFunction::DrawBufferedFrame), payload)
    }

    /// Returns the last valid touch position:
    ///
    /// * Pressure: Amount of pressure applied by the user (0-300)
    /// * X: Touch position on x-axis (0-127)
    /// * Y: Touch position on y-axis (0-63)
    /// * Age: Age of touch press in ms (how long ago it was)
    pub fn get_touch_position(&self) -> ConvertingReceiver<TouchPosition> {
        let payload = vec![0; 0];

        self.device.get(u8::from(Lcd128x64BrickletFunction::GetTouchPosition), payload)
    }

    /// The period in ms is the period with which the [`get_touch_position_callback_receiver`] receiver
    /// is triggered periodically. A value of 0 turns the receiver off.
    ///
    /// If the `value has to change`-parameter is set to true, the receiver is only
    /// triggered after the value has changed. If the value didn't change within the
    /// period, the receiver is triggered immediately on change.
    ///
    /// If it is set to false, the receiver is continuously triggered with the period,
    /// independent of the value.
    ///
    /// The default value is (0, false).
    ///
    /// [`get_touch_position_callback_receiver`]: #method.get_touch_position_callback_receiver
    pub fn set_touch_position_callback_configuration(&self, period: u32, value_has_to_change: bool) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 5];
        payload[0..4].copy_from_slice(&<u32>::to_le_bytes(period));
        payload[4..5].copy_from_slice(&<bool>::to_le_bytes(value_has_to_change));

        self.device.set(u8::from(Lcd128x64BrickletFunction::SetTouchPositionCallbackConfiguration), payload)
    }

    /// Returns the receiver configuration as set by
    /// `Set Touch Position Receiver Configuration`.
    pub fn get_touch_position_callback_configuration(&self) -> ConvertingReceiver<TouchPositionCallbackConfiguration> {
        let payload = vec![0; 0];

        self.device.get(u8::from(Lcd128x64BrickletFunction::GetTouchPositionCallbackConfiguration), payload)
    }

    /// Returns one of four touch gestures that can be automatically detected by the Bricklet.
    ///
    /// The gestures are swipes from left to right, right to left, top to bottom and bottom to top.
    ///
    /// Additionally to the gestures a vector with a start and end position of the gesture is
    /// provided. You can use this vector do determine a more exact location of the gesture (e.g.
    /// the swipe from top to bottom was on the left or right part of the screen).
    ///
    /// The age parameter corresponds to the age of gesture in ms (how long ago it was).
    ///
    /// Associated constants:
    /// * LCD_128X64BRICKLET_GESTURE_LEFT_TO_RIGHT
    ///	* LCD_128X64BRICKLET_GESTURE_RIGHT_TO_LEFT
    ///	* LCD_128X64BRICKLET_GESTURE_TOP_TO_BOTTOM
    ///	* LCD_128X64BRICKLET_GESTURE_BOTTOM_TO_TOP
    pub fn get_touch_gesture(&self) -> ConvertingReceiver<TouchGesture> {
        let payload = vec![0; 0];

        self.device.get(u8::from(Lcd128x64BrickletFunction::GetTouchGesture), payload)
    }

    /// The period in ms is the period with which the [`get_touch_gesture_callback_receiver`] receiver
    /// is triggered periodically. A value of 0 turns the receiver off.
    ///
    /// If the `value has to change`-parameter is set to true, the receiver is only
    /// triggered after the value has changed. If the value didn't change within the
    /// period, the receiver is triggered immediately on change.
    ///
    /// If it is set to false, the receiver is continuously triggered with the period,
    /// independent of the value.
    ///
    /// The default value is (0, false).
    ///
    /// [`get_touch_gesture_callback_receiver`]: #method.get_touch_gesture_callback_receiver
    pub fn set_touch_gesture_callback_configuration(&self, period: u32, value_has_to_change: bool) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 5];
        payload[0..4].copy_from_slice(&<u32>::to_le_bytes(period));
        payload[4..5].copy_from_slice(&<bool>::to_le_bytes(value_has_to_change));

        self.device.set(u8::from(Lcd128x64BrickletFunction::SetTouchGestureCallbackConfiguration), payload)
    }

    /// Returns the receiver configuration as set by
    /// `Set Touch Gesture Receiver Configuration`.
    pub fn get_touch_gesture_callback_configuration(&self) -> ConvertingReceiver<TouchGestureCallbackConfiguration> {
        let payload = vec![0; 0];

        self.device.get(u8::from(Lcd128x64BrickletFunction::GetTouchGestureCallbackConfiguration), payload)
    }

    /// Returns the error count for the communication between Brick and Bricklet.
    ///
    /// The errors are divided into
    ///
    /// * ACK checksum errors,
    /// * message checksum errors,
    /// * framing errors and
    /// * overflow errors.
    ///
    /// The errors counts are for errors that occur on the Bricklet side. All
    /// Bricks have a similar function that returns the errors on the Brick side.
    pub fn get_spitfp_error_count(&self) -> ConvertingReceiver<SpitfpErrorCount> {
        let payload = vec![0; 0];

        self.device.get(u8::from(Lcd128x64BrickletFunction::GetSpitfpErrorCount), payload)
    }

    /// Sets the bootloader mode and returns the status after the requested
    /// mode change was instigated.
    ///
    /// You can change from bootloader mode to firmware mode and vice versa. A change
    /// from bootloader mode to firmware mode will only take place if the entry function,
    /// device identifier and CRC are present and correct.
    ///
    /// This function is used by Brick Viewer during flashing. It should not be
    /// necessary to call it in a normal user program.
    ///
    /// Associated constants:
    /// * LCD_128X64BRICKLET_BOOTLOADER_MODE_BOOTLOADER
    ///	* LCD_128X64BRICKLET_BOOTLOADER_MODE_FIRMWARE
    ///	* LCD_128X64BRICKLET_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT
    ///	* LCD_128X64BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT
    ///	* LCD_128X64BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT
    ///	* LCD_128X64BRICKLET_BOOTLOADER_STATUS_OK
    ///	* LCD_128X64BRICKLET_BOOTLOADER_STATUS_INVALID_MODE
    ///	* LCD_128X64BRICKLET_BOOTLOADER_STATUS_NO_CHANGE
    ///	* LCD_128X64BRICKLET_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT
    ///	* LCD_128X64BRICKLET_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT
    ///	* LCD_128X64BRICKLET_BOOTLOADER_STATUS_CRC_MISMATCH
    pub fn set_bootloader_mode(&self, mode: u8) -> ConvertingReceiver<u8> {
        let mut payload = vec![0; 1];
        payload[0..1].copy_from_slice(&<u8>::to_le_bytes(mode));

        self.device.get(u8::from(Lcd128x64BrickletFunction::SetBootloaderMode), payload)
    }

    /// Returns the current bootloader mode, see `Set Bootloader Mode`.
    ///
    /// Associated constants:
    /// * LCD_128X64BRICKLET_BOOTLOADER_MODE_BOOTLOADER
    ///	* LCD_128X64BRICKLET_BOOTLOADER_MODE_FIRMWARE
    ///	* LCD_128X64BRICKLET_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT
    ///	* LCD_128X64BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT
    ///	* LCD_128X64BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT
    pub fn get_bootloader_mode(&self) -> ConvertingReceiver<u8> {
        let payload = vec![0; 0];

        self.device.get(u8::from(Lcd128x64BrickletFunction::GetBootloaderMode), payload)
    }

    /// Sets the firmware pointer for `Write Firmware`. The pointer has
    /// to be increased by chunks of size 64. The data is written to flash
    /// every 4 chunks (which equals to one page of size 256).
    ///
    /// This function is used by Brick Viewer during flashing. It should not be
    /// necessary to call it in a normal user program.
    pub fn set_write_firmware_pointer(&self, pointer: u32) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 4];
        payload[0..4].copy_from_slice(&<u32>::to_le_bytes(pointer));

        self.device.set(u8::from(Lcd128x64BrickletFunction::SetWriteFirmwarePointer), payload)
    }

    /// Writes 64 Bytes of firmware at the position as written by
    /// `Set Write Firmware Pointer` before. The firmware is written
    /// to flash every 4 chunks.
    ///
    /// You can only write firmware in bootloader mode.
    ///
    /// This function is used by Brick Viewer during flashing. It should not be
    /// necessary to call it in a normal user program.
    pub fn write_firmware(&self, data: [u8; 64]) -> ConvertingReceiver<u8> {
        let mut payload = vec![0; 64];
        payload[0..64].copy_from_slice(&<[u8; 64]>::to_le_bytes(data));

        self.device.get(u8::from(Lcd128x64BrickletFunction::WriteFirmware), payload)
    }

    /// Sets the status LED configuration. By default the LED shows
    /// communication traffic between Brick and Bricklet, it flickers once
    /// for every 10 received data packets.
    ///
    /// You can also turn the LED permanently on/off or show a heartbeat.
    ///
    /// If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    ///
    /// Associated constants:
    /// * LCD_128X64BRICKLET_STATUS_LED_CONFIG_OFF
    ///	* LCD_128X64BRICKLET_STATUS_LED_CONFIG_ON
    ///	* LCD_128X64BRICKLET_STATUS_LED_CONFIG_SHOW_HEARTBEAT
    ///	* LCD_128X64BRICKLET_STATUS_LED_CONFIG_SHOW_STATUS
    pub fn set_status_led_config(&self, config: u8) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 1];
        payload[0..1].copy_from_slice(&<u8>::to_le_bytes(config));

        self.device.set(u8::from(Lcd128x64BrickletFunction::SetStatusLedConfig), payload)
    }

    /// Returns the configuration as set by `Set Status LED Config`
    ///
    /// Associated constants:
    /// * LCD_128X64BRICKLET_STATUS_LED_CONFIG_OFF
    ///	* LCD_128X64BRICKLET_STATUS_LED_CONFIG_ON
    ///	* LCD_128X64BRICKLET_STATUS_LED_CONFIG_SHOW_HEARTBEAT
    ///	* LCD_128X64BRICKLET_STATUS_LED_CONFIG_SHOW_STATUS
    pub fn get_status_led_config(&self) -> ConvertingReceiver<u8> {
        let payload = vec![0; 0];

        self.device.get(u8::from(Lcd128x64BrickletFunction::GetStatusLedConfig), payload)
    }

    /// Returns the temperature in °C as measured inside the microcontroller. The
    /// value returned is not the ambient temperature!
    ///
    /// The temperature is only proportional to the real temperature and it has bad
    /// accuracy. Practically it is only useful as an indicator for
    /// temperature changes.
    pub fn get_chip_temperature(&self) -> ConvertingReceiver<i16> {
        let payload = vec![0; 0];

        self.device.get(u8::from(Lcd128x64BrickletFunction::GetChipTemperature), payload)
    }

    /// Calling this function will reset the Bricklet. All configurations
    /// will be lost.
    ///
    /// After a reset you have to create new device objects,
    /// calling functions on the existing ones will result in
    /// undefined behavior!
    pub fn reset(&self) -> ConvertingReceiver<()> {
        let payload = vec![0; 0];

        self.device.set(u8::from(Lcd128x64BrickletFunction::Reset), payload)
    }

    /// Writes a new UID into flash. If you want to set a new UID
    /// you have to decode the Base58 encoded UID string into an
    /// integer first.
    ///
    /// We recommend that you use Brick Viewer to change the UID.
    pub fn write_uid(&self, uid: u32) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 4];
        payload[0..4].copy_from_slice(&<u32>::to_le_bytes(uid));

        self.device.set(u8::from(Lcd128x64BrickletFunction::WriteUid), payload)
    }

    /// Returns the current UID as an integer. Encode as
    /// Base58 to get the usual string version.
    pub fn read_uid(&self) -> ConvertingReceiver<u32> {
        let payload = vec![0; 0];

        self.device.get(u8::from(Lcd128x64BrickletFunction::ReadUid), payload)
    }

    /// Returns the UID, the UID where the Bricklet is connected to,
    /// the position, the hardware and firmware version as well as the
    /// device identifier.
    ///
    /// The position can be 'a', 'b', 'c' or 'd'.
    ///
    /// The device identifier numbers can be found [here](device_identifier).
    /// |device_identifier_constant|
    pub fn get_identity(&self) -> ConvertingReceiver<Identity> {
        let payload = vec![0; 0];

        self.device.get(u8::from(Lcd128x64BrickletFunction::GetIdentity), payload)
    }
}
