/* ***********************************************************
 * This file was automatically generated on 2018-11-08.      *
 *                                                           *
 * Rust Bindings Version 2.0.3                               *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

//! Passive infrared (PIR) motion sensor, 12m range
use crate::{
    byte_converter::*, converting_callback_receiver::ConvertingCallbackReceiver, converting_receiver::ConvertingReceiver, device::*,
    ip_connection::IpConnection,
};
pub enum MotionDetectorV2BrickletFunction {
    GetMotionDetected,
    SetSensitivity,
    GetSensitivity,
    SetIndicator,
    GetIndicator,
    GetSpitfpErrorCount,
    SetBootloaderMode,
    GetBootloaderMode,
    SetWriteFirmwarePointer,
    WriteFirmware,
    SetStatusLedConfig,
    GetStatusLedConfig,
    GetChipTemperature,
    Reset,
    WriteUid,
    ReadUid,
    GetIdentity,
    CallbackMotionDetected,
    CallbackDetectionCycleEnded,
}
impl From<MotionDetectorV2BrickletFunction> for u8 {
    fn from(fun: MotionDetectorV2BrickletFunction) -> Self {
        match fun {
            MotionDetectorV2BrickletFunction::GetMotionDetected => 1,
            MotionDetectorV2BrickletFunction::SetSensitivity => 2,
            MotionDetectorV2BrickletFunction::GetSensitivity => 3,
            MotionDetectorV2BrickletFunction::SetIndicator => 4,
            MotionDetectorV2BrickletFunction::GetIndicator => 5,
            MotionDetectorV2BrickletFunction::GetSpitfpErrorCount => 234,
            MotionDetectorV2BrickletFunction::SetBootloaderMode => 235,
            MotionDetectorV2BrickletFunction::GetBootloaderMode => 236,
            MotionDetectorV2BrickletFunction::SetWriteFirmwarePointer => 237,
            MotionDetectorV2BrickletFunction::WriteFirmware => 238,
            MotionDetectorV2BrickletFunction::SetStatusLedConfig => 239,
            MotionDetectorV2BrickletFunction::GetStatusLedConfig => 240,
            MotionDetectorV2BrickletFunction::GetChipTemperature => 242,
            MotionDetectorV2BrickletFunction::Reset => 243,
            MotionDetectorV2BrickletFunction::WriteUid => 248,
            MotionDetectorV2BrickletFunction::ReadUid => 249,
            MotionDetectorV2BrickletFunction::GetIdentity => 255,
            MotionDetectorV2BrickletFunction::CallbackMotionDetected => 6,
            MotionDetectorV2BrickletFunction::CallbackDetectionCycleEnded => 7,
        }
    }
}
pub const MOTION_DETECTOR_V2_BRICKLET_MOTION_NOT_DETECTED: u8 = 0;
pub const MOTION_DETECTOR_V2_BRICKLET_MOTION_DETECTED: u8 = 1;
pub const MOTION_DETECTOR_V2_BRICKLET_BOOTLOADER_MODE_BOOTLOADER: u8 = 0;
pub const MOTION_DETECTOR_V2_BRICKLET_BOOTLOADER_MODE_FIRMWARE: u8 = 1;
pub const MOTION_DETECTOR_V2_BRICKLET_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT: u8 = 2;
pub const MOTION_DETECTOR_V2_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT: u8 = 3;
pub const MOTION_DETECTOR_V2_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT: u8 = 4;
pub const MOTION_DETECTOR_V2_BRICKLET_BOOTLOADER_STATUS_OK: u8 = 0;
pub const MOTION_DETECTOR_V2_BRICKLET_BOOTLOADER_STATUS_INVALID_MODE: u8 = 1;
pub const MOTION_DETECTOR_V2_BRICKLET_BOOTLOADER_STATUS_NO_CHANGE: u8 = 2;
pub const MOTION_DETECTOR_V2_BRICKLET_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT: u8 = 3;
pub const MOTION_DETECTOR_V2_BRICKLET_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT: u8 = 4;
pub const MOTION_DETECTOR_V2_BRICKLET_BOOTLOADER_STATUS_CRC_MISMATCH: u8 = 5;
pub const MOTION_DETECTOR_V2_BRICKLET_STATUS_LED_CONFIG_OFF: u8 = 0;
pub const MOTION_DETECTOR_V2_BRICKLET_STATUS_LED_CONFIG_ON: u8 = 1;
pub const MOTION_DETECTOR_V2_BRICKLET_STATUS_LED_CONFIG_SHOW_HEARTBEAT: u8 = 2;
pub const MOTION_DETECTOR_V2_BRICKLET_STATUS_LED_CONFIG_SHOW_STATUS: u8 = 3;

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct Indicator {
    pub top_left: u8,
    pub top_right: u8,
    pub bottom: u8,
}
impl FromByteSlice for Indicator {
    fn bytes_expected() -> usize { 3 }
    fn from_le_bytes(bytes: &[u8]) -> Indicator {
        Indicator {
            top_left: <u8>::from_le_bytes(&bytes[0..1]),
            top_right: <u8>::from_le_bytes(&bytes[1..2]),
            bottom: <u8>::from_le_bytes(&bytes[2..3]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct SpitfpErrorCount {
    pub error_count_ack_checksum: u32,
    pub error_count_message_checksum: u32,
    pub error_count_frame: u32,
    pub error_count_overflow: u32,
}
impl FromByteSlice for SpitfpErrorCount {
    fn bytes_expected() -> usize { 16 }
    fn from_le_bytes(bytes: &[u8]) -> SpitfpErrorCount {
        SpitfpErrorCount {
            error_count_ack_checksum: <u32>::from_le_bytes(&bytes[0..4]),
            error_count_message_checksum: <u32>::from_le_bytes(&bytes[4..8]),
            error_count_frame: <u32>::from_le_bytes(&bytes[8..12]),
            error_count_overflow: <u32>::from_le_bytes(&bytes[12..16]),
        }
    }
}

#[derive(Clone, Debug, Default, PartialEq, Eq, Hash)]
pub struct Identity {
    pub uid: String,
    pub connected_uid: String,
    pub position: char,
    pub hardware_version: [u8; 3],
    pub firmware_version: [u8; 3],
    pub device_identifier: u16,
}
impl FromByteSlice for Identity {
    fn bytes_expected() -> usize { 25 }
    fn from_le_bytes(bytes: &[u8]) -> Identity {
        Identity {
            uid: <String>::from_le_bytes(&bytes[0..8]),
            connected_uid: <String>::from_le_bytes(&bytes[8..16]),
            position: <char>::from_le_bytes(&bytes[16..17]),
            hardware_version: <[u8; 3]>::from_le_bytes(&bytes[17..20]),
            firmware_version: <[u8; 3]>::from_le_bytes(&bytes[20..23]),
            device_identifier: <u16>::from_le_bytes(&bytes[23..25]),
        }
    }
}

/// Passive infrared (PIR) motion sensor, 12m range
#[derive(Clone)]
pub struct MotionDetectorV2Bricklet {
    device: Device,
}
impl MotionDetectorV2Bricklet {
    pub const DEVICE_IDENTIFIER: u16 = 292;
    pub const DEVICE_DISPLAY_NAME: &'static str = "Motion Detector Bricklet 2.0";
    /// Creates an object with the unique device ID `uid`. This object can then be used after the IP Connection `ip_connection` is connected.
    pub fn new(uid: &str, ip_connection: &IpConnection) -> MotionDetectorV2Bricklet {
        let mut result = MotionDetectorV2Bricklet { device: Device::new([2, 0, 0], uid, ip_connection, 0) };
        result.device.response_expected[u8::from(MotionDetectorV2BrickletFunction::GetMotionDetected) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(MotionDetectorV2BrickletFunction::SetSensitivity) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(MotionDetectorV2BrickletFunction::GetSensitivity) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(MotionDetectorV2BrickletFunction::SetIndicator) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(MotionDetectorV2BrickletFunction::GetIndicator) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(MotionDetectorV2BrickletFunction::GetSpitfpErrorCount) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(MotionDetectorV2BrickletFunction::SetBootloaderMode) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(MotionDetectorV2BrickletFunction::GetBootloaderMode) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(MotionDetectorV2BrickletFunction::SetWriteFirmwarePointer) as usize] =
            ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(MotionDetectorV2BrickletFunction::WriteFirmware) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(MotionDetectorV2BrickletFunction::SetStatusLedConfig) as usize] =
            ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(MotionDetectorV2BrickletFunction::GetStatusLedConfig) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(MotionDetectorV2BrickletFunction::GetChipTemperature) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(MotionDetectorV2BrickletFunction::Reset) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(MotionDetectorV2BrickletFunction::WriteUid) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(MotionDetectorV2BrickletFunction::ReadUid) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(MotionDetectorV2BrickletFunction::GetIdentity) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result
    }

    /// Returns the response expected flag for the function specified by the function ID parameter.
    /// It is true if the function is expected to send a response, false otherwise.
    ///
    /// For getter functions this is enabled by default and cannot be disabled, because those
    /// functions will always send a response. For callback configuration functions it is enabled
    /// by default too, but can be disabled by [`set_response_expected`](crate::motion_detector_v2_bricklet::MotionDetectorV2Bricklet::set_response_expected).
    /// For setter functions it is disabled by default and can be enabled.
    ///
    /// Enabling the response expected flag for a setter function allows to detect timeouts
    /// and other error conditions calls of this setter as well. The device will then send a response
    /// for this purpose. If this flag is disabled for a setter function then no response is send
    /// and errors are silently ignored, because they cannot be detected.
    ///
    /// See [`set_response_expected`](crate::motion_detector_v2_bricklet::MotionDetectorV2Bricklet::set_response_expected) for the list of function ID constants available for this function.
    pub fn get_response_expected(&mut self, fun: MotionDetectorV2BrickletFunction) -> Result<bool, GetResponseExpectedError> {
        self.device.get_response_expected(u8::from(fun))
    }

    /// Changes the response expected flag of the function specified by the function ID parameter.
    /// This flag can only be changed for setter (default value: false) and callback configuration
    /// functions (default value: true). For getter functions it is always enabled.
    ///
    /// Enabling the response expected flag for a setter function allows to detect timeouts and
    /// other error conditions calls of this setter as well. The device will then send a response
    /// for this purpose. If this flag is disabled for a setter function then no response is send
    /// and errors are silently ignored, because they cannot be detected.
    pub fn set_response_expected(
        &mut self,
        fun: MotionDetectorV2BrickletFunction,
        response_expected: bool,
    ) -> Result<(), SetResponseExpectedError> {
        self.device.set_response_expected(u8::from(fun), response_expected)
    }

    /// Changes the response expected flag for all setter and callback configuration functions of this device at once.
    pub fn set_response_expected_all(&mut self, response_expected: bool) { self.device.set_response_expected_all(response_expected) }

    /// This receiver is called after a motion was detected.
    pub fn get_motion_detected_callback_receiver(&self) -> ConvertingCallbackReceiver<()> {
        self.device.get_callback_receiver(u8::from(MotionDetectorV2BrickletFunction::CallbackMotionDetected))
    }

    /// This receiver is called when the detection cycle ended. When this
    /// receiver is called, a new motion can be detected again after approximately 2
    /// seconds.
    pub fn get_detection_cycle_ended_callback_receiver(&self) -> ConvertingCallbackReceiver<()> {
        self.device.get_callback_receiver(u8::from(MotionDetectorV2BrickletFunction::CallbackDetectionCycleEnded))
    }

    /// Returns 1 if a motion was detected. How long this returns 1 after a motion
    /// was detected can be adjusted with one of the small potentiometers on the
    /// Motion Detector Bricklet, see `here
    /// <motion_detector_bricklet_sensitivity_delay_block_time>`.
    ///
    /// There is also a blue LED on the Bricklet that is on as long as the Bricklet is
    /// in the motion detected state.
    ///
    /// Associated constants:
    /// * MOTION_DETECTOR_V2BRICKLET_MOTION_NOT_DETECTED
    ///	* MOTION_DETECTOR_V2BRICKLET_MOTION_DETECTED
    pub fn get_motion_detected(&self) -> ConvertingReceiver<u8> {
        let payload = vec![0; 0];

        self.device.get(u8::from(MotionDetectorV2BrickletFunction::GetMotionDetected), payload)
    }

    /// Sets the sensitivity of the PIR sensor. The range is 0-100. At full
    /// sensitivity (100), the Bricklet can detect motion in a range of approximately 12m.
    ///
    /// The actual range depends on many things in the environment (e.g. reflections) and the
    /// size of the object to be detected. While a big person might be detected in a range
    /// of 10m a cat may only be detected at 2m distance with the same setting.
    ///
    /// So you will have to find a good sensitivity for your application by trial and error.
    ///
    /// The default value is 50.
    pub fn set_sensitivity(&self, sensitivity: u8) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 1];
        payload[0..1].copy_from_slice(&<u8>::to_le_bytes(sensitivity));

        self.device.set(u8::from(MotionDetectorV2BrickletFunction::SetSensitivity), payload)
    }

    /// Returns the sensitivity as set by `Set Sensitivity`.
    pub fn get_sensitivity(&self) -> ConvertingReceiver<u8> {
        let payload = vec![0; 0];

        self.device.get(u8::from(MotionDetectorV2BrickletFunction::GetSensitivity), payload)
    }

    /// Sets the blue backlight of the fresnel lens. The backlight consists of
    /// three LEDs. The brightness of each LED can be controlled with a 8-bit value
    /// (0-255). A value of 0 turns the LED off and a value of 255 turns the LED
    /// to full brightness.
    ///
    /// The default value is 0, 0, 0.
    pub fn set_indicator(&self, top_left: u8, top_right: u8, bottom: u8) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 3];
        payload[0..1].copy_from_slice(&<u8>::to_le_bytes(top_left));
        payload[1..2].copy_from_slice(&<u8>::to_le_bytes(top_right));
        payload[2..3].copy_from_slice(&<u8>::to_le_bytes(bottom));

        self.device.set(u8::from(MotionDetectorV2BrickletFunction::SetIndicator), payload)
    }

    /// Returns the indicator configuration as set by `Set Indicator`.
    pub fn get_indicator(&self) -> ConvertingReceiver<Indicator> {
        let payload = vec![0; 0];

        self.device.get(u8::from(MotionDetectorV2BrickletFunction::GetIndicator), payload)
    }

    /// Returns the error count for the communication between Brick and Bricklet.
    ///
    /// The errors are divided into
    ///
    /// * ACK checksum errors,
    /// * message checksum errors,
    /// * framing errors and
    /// * overflow errors.
    ///
    /// The errors counts are for errors that occur on the Bricklet side. All
    /// Bricks have a similar function that returns the errors on the Brick side.
    pub fn get_spitfp_error_count(&self) -> ConvertingReceiver<SpitfpErrorCount> {
        let payload = vec![0; 0];

        self.device.get(u8::from(MotionDetectorV2BrickletFunction::GetSpitfpErrorCount), payload)
    }

    /// Sets the bootloader mode and returns the status after the requested
    /// mode change was instigated.
    ///
    /// You can change from bootloader mode to firmware mode and vice versa. A change
    /// from bootloader mode to firmware mode will only take place if the entry function,
    /// device identifier and CRC are present and correct.
    ///
    /// This function is used by Brick Viewer during flashing. It should not be
    /// necessary to call it in a normal user program.
    ///
    /// Associated constants:
    /// * MOTION_DETECTOR_V2BRICKLET_BOOTLOADER_MODE_BOOTLOADER
    ///	* MOTION_DETECTOR_V2BRICKLET_BOOTLOADER_MODE_FIRMWARE
    ///	* MOTION_DETECTOR_V2BRICKLET_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT
    ///	* MOTION_DETECTOR_V2BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT
    ///	* MOTION_DETECTOR_V2BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT
    ///	* MOTION_DETECTOR_V2BRICKLET_BOOTLOADER_STATUS_OK
    ///	* MOTION_DETECTOR_V2BRICKLET_BOOTLOADER_STATUS_INVALID_MODE
    ///	* MOTION_DETECTOR_V2BRICKLET_BOOTLOADER_STATUS_NO_CHANGE
    ///	* MOTION_DETECTOR_V2BRICKLET_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT
    ///	* MOTION_DETECTOR_V2BRICKLET_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT
    ///	* MOTION_DETECTOR_V2BRICKLET_BOOTLOADER_STATUS_CRC_MISMATCH
    pub fn set_bootloader_mode(&self, mode: u8) -> ConvertingReceiver<u8> {
        let mut payload = vec![0; 1];
        payload[0..1].copy_from_slice(&<u8>::to_le_bytes(mode));

        self.device.get(u8::from(MotionDetectorV2BrickletFunction::SetBootloaderMode), payload)
    }

    /// Returns the current bootloader mode, see `Set Bootloader Mode`.
    ///
    /// Associated constants:
    /// * MOTION_DETECTOR_V2BRICKLET_BOOTLOADER_MODE_BOOTLOADER
    ///	* MOTION_DETECTOR_V2BRICKLET_BOOTLOADER_MODE_FIRMWARE
    ///	* MOTION_DETECTOR_V2BRICKLET_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT
    ///	* MOTION_DETECTOR_V2BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT
    ///	* MOTION_DETECTOR_V2BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT
    pub fn get_bootloader_mode(&self) -> ConvertingReceiver<u8> {
        let payload = vec![0; 0];

        self.device.get(u8::from(MotionDetectorV2BrickletFunction::GetBootloaderMode), payload)
    }

    /// Sets the firmware pointer for `Write Firmware`. The pointer has
    /// to be increased by chunks of size 64. The data is written to flash
    /// every 4 chunks (which equals to one page of size 256).
    ///
    /// This function is used by Brick Viewer during flashing. It should not be
    /// necessary to call it in a normal user program.
    pub fn set_write_firmware_pointer(&self, pointer: u32) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 4];
        payload[0..4].copy_from_slice(&<u32>::to_le_bytes(pointer));

        self.device.set(u8::from(MotionDetectorV2BrickletFunction::SetWriteFirmwarePointer), payload)
    }

    /// Writes 64 Bytes of firmware at the position as written by
    /// `Set Write Firmware Pointer` before. The firmware is written
    /// to flash every 4 chunks.
    ///
    /// You can only write firmware in bootloader mode.
    ///
    /// This function is used by Brick Viewer during flashing. It should not be
    /// necessary to call it in a normal user program.
    pub fn write_firmware(&self, data: [u8; 64]) -> ConvertingReceiver<u8> {
        let mut payload = vec![0; 64];
        payload[0..64].copy_from_slice(&<[u8; 64]>::to_le_bytes(data));

        self.device.get(u8::from(MotionDetectorV2BrickletFunction::WriteFirmware), payload)
    }

    /// Sets the status LED configuration. By default the LED shows
    /// communication traffic between Brick and Bricklet, it flickers once
    /// for every 10 received data packets.
    ///
    /// You can also turn the LED permanently on/off or show a heartbeat.
    ///
    /// If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    ///
    /// Associated constants:
    /// * MOTION_DETECTOR_V2BRICKLET_STATUS_LED_CONFIG_OFF
    ///	* MOTION_DETECTOR_V2BRICKLET_STATUS_LED_CONFIG_ON
    ///	* MOTION_DETECTOR_V2BRICKLET_STATUS_LED_CONFIG_SHOW_HEARTBEAT
    ///	* MOTION_DETECTOR_V2BRICKLET_STATUS_LED_CONFIG_SHOW_STATUS
    pub fn set_status_led_config(&self, config: u8) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 1];
        payload[0..1].copy_from_slice(&<u8>::to_le_bytes(config));

        self.device.set(u8::from(MotionDetectorV2BrickletFunction::SetStatusLedConfig), payload)
    }

    /// Returns the configuration as set by `Set Status LED Config`
    ///
    /// Associated constants:
    /// * MOTION_DETECTOR_V2BRICKLET_STATUS_LED_CONFIG_OFF
    ///	* MOTION_DETECTOR_V2BRICKLET_STATUS_LED_CONFIG_ON
    ///	* MOTION_DETECTOR_V2BRICKLET_STATUS_LED_CONFIG_SHOW_HEARTBEAT
    ///	* MOTION_DETECTOR_V2BRICKLET_STATUS_LED_CONFIG_SHOW_STATUS
    pub fn get_status_led_config(&self) -> ConvertingReceiver<u8> {
        let payload = vec![0; 0];

        self.device.get(u8::from(MotionDetectorV2BrickletFunction::GetStatusLedConfig), payload)
    }

    /// Returns the temperature in °C as measured inside the microcontroller. The
    /// value returned is not the ambient temperature!
    ///
    /// The temperature is only proportional to the real temperature and it has bad
    /// accuracy. Practically it is only useful as an indicator for
    /// temperature changes.
    pub fn get_chip_temperature(&self) -> ConvertingReceiver<i16> {
        let payload = vec![0; 0];

        self.device.get(u8::from(MotionDetectorV2BrickletFunction::GetChipTemperature), payload)
    }

    /// Calling this function will reset the Bricklet. All configurations
    /// will be lost.
    ///
    /// After a reset you have to create new device objects,
    /// calling functions on the existing ones will result in
    /// undefined behavior!
    pub fn reset(&self) -> ConvertingReceiver<()> {
        let payload = vec![0; 0];

        self.device.set(u8::from(MotionDetectorV2BrickletFunction::Reset), payload)
    }

    /// Writes a new UID into flash. If you want to set a new UID
    /// you have to decode the Base58 encoded UID string into an
    /// integer first.
    ///
    /// We recommend that you use Brick Viewer to change the UID.
    pub fn write_uid(&self, uid: u32) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 4];
        payload[0..4].copy_from_slice(&<u32>::to_le_bytes(uid));

        self.device.set(u8::from(MotionDetectorV2BrickletFunction::WriteUid), payload)
    }

    /// Returns the current UID as an integer. Encode as
    /// Base58 to get the usual string version.
    pub fn read_uid(&self) -> ConvertingReceiver<u32> {
        let payload = vec![0; 0];

        self.device.get(u8::from(MotionDetectorV2BrickletFunction::ReadUid), payload)
    }

    /// Returns the UID, the UID where the Bricklet is connected to,
    /// the position, the hardware and firmware version as well as the
    /// device identifier.
    ///
    /// The position can be 'a', 'b', 'c' or 'd'.
    ///
    /// The device identifier numbers can be found [here](device_identifier).
    /// |device_identifier_constant|
    pub fn get_identity(&self) -> ConvertingReceiver<Identity> {
        let payload = vec![0; 0];

        self.device.get(u8::from(MotionDetectorV2BrickletFunction::GetIdentity), payload)
    }
}
