/* ***********************************************************
 * This file was automatically generated on 2018-11-08.      *
 *                                                           *
 * Rust Bindings Version 2.0.3                               *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

//! Reads temperatures from Pt100 und Pt1000 sensors
use crate::{
    byte_converter::*, converting_callback_receiver::ConvertingCallbackReceiver, converting_receiver::ConvertingReceiver, device::*,
    ip_connection::IpConnection,
};
pub enum PtcV2BrickletFunction {
    GetTemperature,
    SetTemperatureCallbackConfiguration,
    GetTemperatureCallbackConfiguration,
    GetResistance,
    SetResistanceCallbackConfiguration,
    GetResistanceCallbackConfiguration,
    SetNoiseRejectionFilter,
    GetNoiseRejectionFilter,
    IsSensorConnected,
    SetWireMode,
    GetWireMode,
    SetMovingAverageConfiguration,
    GetMovingAverageConfiguration,
    SetSensorConnectedCallbackConfiguration,
    GetSensorConnectedCallbackConfiguration,
    GetSpitfpErrorCount,
    SetBootloaderMode,
    GetBootloaderMode,
    SetWriteFirmwarePointer,
    WriteFirmware,
    SetStatusLedConfig,
    GetStatusLedConfig,
    GetChipTemperature,
    Reset,
    WriteUid,
    ReadUid,
    GetIdentity,
    CallbackTemperature,
    CallbackResistance,
    CallbackSensorConnected,
}
impl From<PtcV2BrickletFunction> for u8 {
    fn from(fun: PtcV2BrickletFunction) -> Self {
        match fun {
            PtcV2BrickletFunction::GetTemperature => 1,
            PtcV2BrickletFunction::SetTemperatureCallbackConfiguration => 2,
            PtcV2BrickletFunction::GetTemperatureCallbackConfiguration => 3,
            PtcV2BrickletFunction::GetResistance => 5,
            PtcV2BrickletFunction::SetResistanceCallbackConfiguration => 6,
            PtcV2BrickletFunction::GetResistanceCallbackConfiguration => 7,
            PtcV2BrickletFunction::SetNoiseRejectionFilter => 9,
            PtcV2BrickletFunction::GetNoiseRejectionFilter => 10,
            PtcV2BrickletFunction::IsSensorConnected => 11,
            PtcV2BrickletFunction::SetWireMode => 12,
            PtcV2BrickletFunction::GetWireMode => 13,
            PtcV2BrickletFunction::SetMovingAverageConfiguration => 14,
            PtcV2BrickletFunction::GetMovingAverageConfiguration => 15,
            PtcV2BrickletFunction::SetSensorConnectedCallbackConfiguration => 16,
            PtcV2BrickletFunction::GetSensorConnectedCallbackConfiguration => 17,
            PtcV2BrickletFunction::GetSpitfpErrorCount => 234,
            PtcV2BrickletFunction::SetBootloaderMode => 235,
            PtcV2BrickletFunction::GetBootloaderMode => 236,
            PtcV2BrickletFunction::SetWriteFirmwarePointer => 237,
            PtcV2BrickletFunction::WriteFirmware => 238,
            PtcV2BrickletFunction::SetStatusLedConfig => 239,
            PtcV2BrickletFunction::GetStatusLedConfig => 240,
            PtcV2BrickletFunction::GetChipTemperature => 242,
            PtcV2BrickletFunction::Reset => 243,
            PtcV2BrickletFunction::WriteUid => 248,
            PtcV2BrickletFunction::ReadUid => 249,
            PtcV2BrickletFunction::GetIdentity => 255,
            PtcV2BrickletFunction::CallbackTemperature => 4,
            PtcV2BrickletFunction::CallbackResistance => 8,
            PtcV2BrickletFunction::CallbackSensorConnected => 18,
        }
    }
}
pub const PTC_V2_BRICKLET_THRESHOLD_OPTION_OFF: char = 'x';
pub const PTC_V2_BRICKLET_THRESHOLD_OPTION_OUTSIDE: char = 'o';
pub const PTC_V2_BRICKLET_THRESHOLD_OPTION_INSIDE: char = 'i';
pub const PTC_V2_BRICKLET_THRESHOLD_OPTION_SMALLER: char = '<';
pub const PTC_V2_BRICKLET_THRESHOLD_OPTION_GREATER: char = '>';
pub const PTC_V2_BRICKLET_FILTER_OPTION_50HZ: u8 = 0;
pub const PTC_V2_BRICKLET_FILTER_OPTION_60HZ: u8 = 1;
pub const PTC_V2_BRICKLET_WIRE_MODE_2: u8 = 2;
pub const PTC_V2_BRICKLET_WIRE_MODE_3: u8 = 3;
pub const PTC_V2_BRICKLET_WIRE_MODE_4: u8 = 4;
pub const PTC_V2_BRICKLET_BOOTLOADER_MODE_BOOTLOADER: u8 = 0;
pub const PTC_V2_BRICKLET_BOOTLOADER_MODE_FIRMWARE: u8 = 1;
pub const PTC_V2_BRICKLET_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT: u8 = 2;
pub const PTC_V2_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT: u8 = 3;
pub const PTC_V2_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT: u8 = 4;
pub const PTC_V2_BRICKLET_BOOTLOADER_STATUS_OK: u8 = 0;
pub const PTC_V2_BRICKLET_BOOTLOADER_STATUS_INVALID_MODE: u8 = 1;
pub const PTC_V2_BRICKLET_BOOTLOADER_STATUS_NO_CHANGE: u8 = 2;
pub const PTC_V2_BRICKLET_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT: u8 = 3;
pub const PTC_V2_BRICKLET_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT: u8 = 4;
pub const PTC_V2_BRICKLET_BOOTLOADER_STATUS_CRC_MISMATCH: u8 = 5;
pub const PTC_V2_BRICKLET_STATUS_LED_CONFIG_OFF: u8 = 0;
pub const PTC_V2_BRICKLET_STATUS_LED_CONFIG_ON: u8 = 1;
pub const PTC_V2_BRICKLET_STATUS_LED_CONFIG_SHOW_HEARTBEAT: u8 = 2;
pub const PTC_V2_BRICKLET_STATUS_LED_CONFIG_SHOW_STATUS: u8 = 3;

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct TemperatureCallbackConfiguration {
    pub period: u32,
    pub value_has_to_change: bool,
    pub option: char,
    pub min: i32,
    pub max: i32,
}
impl FromByteSlice for TemperatureCallbackConfiguration {
    fn bytes_expected() -> usize { 14 }
    fn from_le_bytes(bytes: &[u8]) -> TemperatureCallbackConfiguration {
        TemperatureCallbackConfiguration {
            period: <u32>::from_le_bytes(&bytes[0..4]),
            value_has_to_change: <bool>::from_le_bytes(&bytes[4..5]),
            option: <char>::from_le_bytes(&bytes[5..6]),
            min: <i32>::from_le_bytes(&bytes[6..10]),
            max: <i32>::from_le_bytes(&bytes[10..14]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct ResistanceCallbackConfiguration {
    pub period: u32,
    pub value_has_to_change: bool,
    pub option: char,
    pub min: i32,
    pub max: i32,
}
impl FromByteSlice for ResistanceCallbackConfiguration {
    fn bytes_expected() -> usize { 14 }
    fn from_le_bytes(bytes: &[u8]) -> ResistanceCallbackConfiguration {
        ResistanceCallbackConfiguration {
            period: <u32>::from_le_bytes(&bytes[0..4]),
            value_has_to_change: <bool>::from_le_bytes(&bytes[4..5]),
            option: <char>::from_le_bytes(&bytes[5..6]),
            min: <i32>::from_le_bytes(&bytes[6..10]),
            max: <i32>::from_le_bytes(&bytes[10..14]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct MovingAverageConfiguration {
    pub moving_average_length_resistance: u16,
    pub moving_average_length_temperature: u16,
}
impl FromByteSlice for MovingAverageConfiguration {
    fn bytes_expected() -> usize { 4 }
    fn from_le_bytes(bytes: &[u8]) -> MovingAverageConfiguration {
        MovingAverageConfiguration {
            moving_average_length_resistance: <u16>::from_le_bytes(&bytes[0..2]),
            moving_average_length_temperature: <u16>::from_le_bytes(&bytes[2..4]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct SpitfpErrorCount {
    pub error_count_ack_checksum: u32,
    pub error_count_message_checksum: u32,
    pub error_count_frame: u32,
    pub error_count_overflow: u32,
}
impl FromByteSlice for SpitfpErrorCount {
    fn bytes_expected() -> usize { 16 }
    fn from_le_bytes(bytes: &[u8]) -> SpitfpErrorCount {
        SpitfpErrorCount {
            error_count_ack_checksum: <u32>::from_le_bytes(&bytes[0..4]),
            error_count_message_checksum: <u32>::from_le_bytes(&bytes[4..8]),
            error_count_frame: <u32>::from_le_bytes(&bytes[8..12]),
            error_count_overflow: <u32>::from_le_bytes(&bytes[12..16]),
        }
    }
}

#[derive(Clone, Debug, Default, PartialEq, Eq, Hash)]
pub struct Identity {
    pub uid: String,
    pub connected_uid: String,
    pub position: char,
    pub hardware_version: [u8; 3],
    pub firmware_version: [u8; 3],
    pub device_identifier: u16,
}
impl FromByteSlice for Identity {
    fn bytes_expected() -> usize { 25 }
    fn from_le_bytes(bytes: &[u8]) -> Identity {
        Identity {
            uid: <String>::from_le_bytes(&bytes[0..8]),
            connected_uid: <String>::from_le_bytes(&bytes[8..16]),
            position: <char>::from_le_bytes(&bytes[16..17]),
            hardware_version: <[u8; 3]>::from_le_bytes(&bytes[17..20]),
            firmware_version: <[u8; 3]>::from_le_bytes(&bytes[20..23]),
            device_identifier: <u16>::from_le_bytes(&bytes[23..25]),
        }
    }
}

/// Reads temperatures from Pt100 und Pt1000 sensors
#[derive(Clone)]
pub struct PtcV2Bricklet {
    device: Device,
}
impl PtcV2Bricklet {
    pub const DEVICE_IDENTIFIER: u16 = 2101;
    pub const DEVICE_DISPLAY_NAME: &'static str = "PTC Bricklet 2.0";
    /// Creates an object with the unique device ID `uid`. This object can then be used after the IP Connection `ip_connection` is connected.
    pub fn new(uid: &str, ip_connection: &IpConnection) -> PtcV2Bricklet {
        let mut result = PtcV2Bricklet { device: Device::new([2, 0, 0], uid, ip_connection, 0) };
        result.device.response_expected[u8::from(PtcV2BrickletFunction::GetTemperature) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(PtcV2BrickletFunction::SetTemperatureCallbackConfiguration) as usize] =
            ResponseExpectedFlag::True;
        result.device.response_expected[u8::from(PtcV2BrickletFunction::GetTemperatureCallbackConfiguration) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(PtcV2BrickletFunction::GetResistance) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(PtcV2BrickletFunction::SetResistanceCallbackConfiguration) as usize] =
            ResponseExpectedFlag::True;
        result.device.response_expected[u8::from(PtcV2BrickletFunction::GetResistanceCallbackConfiguration) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(PtcV2BrickletFunction::SetNoiseRejectionFilter) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(PtcV2BrickletFunction::GetNoiseRejectionFilter) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(PtcV2BrickletFunction::IsSensorConnected) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(PtcV2BrickletFunction::SetWireMode) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(PtcV2BrickletFunction::GetWireMode) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(PtcV2BrickletFunction::SetMovingAverageConfiguration) as usize] =
            ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(PtcV2BrickletFunction::GetMovingAverageConfiguration) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(PtcV2BrickletFunction::SetSensorConnectedCallbackConfiguration) as usize] =
            ResponseExpectedFlag::True;
        result.device.response_expected[u8::from(PtcV2BrickletFunction::GetSensorConnectedCallbackConfiguration) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(PtcV2BrickletFunction::GetSpitfpErrorCount) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(PtcV2BrickletFunction::SetBootloaderMode) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(PtcV2BrickletFunction::GetBootloaderMode) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(PtcV2BrickletFunction::SetWriteFirmwarePointer) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(PtcV2BrickletFunction::WriteFirmware) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(PtcV2BrickletFunction::SetStatusLedConfig) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(PtcV2BrickletFunction::GetStatusLedConfig) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(PtcV2BrickletFunction::GetChipTemperature) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(PtcV2BrickletFunction::Reset) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(PtcV2BrickletFunction::WriteUid) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(PtcV2BrickletFunction::ReadUid) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(PtcV2BrickletFunction::GetIdentity) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result
    }

    /// Returns the response expected flag for the function specified by the function ID parameter.
    /// It is true if the function is expected to send a response, false otherwise.
    ///
    /// For getter functions this is enabled by default and cannot be disabled, because those
    /// functions will always send a response. For callback configuration functions it is enabled
    /// by default too, but can be disabled by [`set_response_expected`](crate::ptc_v2_bricklet::PtcV2Bricklet::set_response_expected).
    /// For setter functions it is disabled by default and can be enabled.
    ///
    /// Enabling the response expected flag for a setter function allows to detect timeouts
    /// and other error conditions calls of this setter as well. The device will then send a response
    /// for this purpose. If this flag is disabled for a setter function then no response is send
    /// and errors are silently ignored, because they cannot be detected.
    ///
    /// See [`set_response_expected`](crate::ptc_v2_bricklet::PtcV2Bricklet::set_response_expected) for the list of function ID constants available for this function.
    pub fn get_response_expected(&mut self, fun: PtcV2BrickletFunction) -> Result<bool, GetResponseExpectedError> {
        self.device.get_response_expected(u8::from(fun))
    }

    /// Changes the response expected flag of the function specified by the function ID parameter.
    /// This flag can only be changed for setter (default value: false) and callback configuration
    /// functions (default value: true). For getter functions it is always enabled.
    ///
    /// Enabling the response expected flag for a setter function allows to detect timeouts and
    /// other error conditions calls of this setter as well. The device will then send a response
    /// for this purpose. If this flag is disabled for a setter function then no response is send
    /// and errors are silently ignored, because they cannot be detected.
    pub fn set_response_expected(&mut self, fun: PtcV2BrickletFunction, response_expected: bool) -> Result<(), SetResponseExpectedError> {
        self.device.set_response_expected(u8::from(fun), response_expected)
    }

    /// Changes the response expected flag for all setter and callback configuration functions of this device at once.
    pub fn set_response_expected_all(&mut self, response_expected: bool) { self.device.set_response_expected_all(response_expected) }

    /// This receiver is triggered periodically according to the configuration set by
    /// `Set Temperature Receiver Configuration`.
    ///
    /// The parameter is the same as `Get Temperature`.
    pub fn get_temperature_callback_receiver(&self) -> ConvertingCallbackReceiver<i32> {
        self.device.get_callback_receiver(u8::from(PtcV2BrickletFunction::CallbackTemperature))
    }

    /// This receiver is triggered periodically according to the configuration set by
    /// `Set Resistance Receiver Configuration`.
    ///
    /// The parameter is the same as `Get Resistance`.
    pub fn get_resistance_callback_receiver(&self) -> ConvertingCallbackReceiver<i32> {
        self.device.get_callback_receiver(u8::from(PtcV2BrickletFunction::CallbackResistance))
    }

    /// This receiver is triggered periodically according to the configuration set by
    /// `Set Sensor Connected Receiver Configuration`.
    ///
    /// The parameter is the same as `Is Sensor Connected`.
    pub fn get_sensor_connected_callback_receiver(&self) -> ConvertingCallbackReceiver<bool> {
        self.device.get_callback_receiver(u8::from(PtcV2BrickletFunction::CallbackSensorConnected))
    }

    /// Returns the temperature of the connected sensor. The value
    /// has a range of -246 to 849 °C and is given in °C/100,
    /// e.g. a value of 4223 means that a temperature of 42.23 °C is measured.
    ///
    ///
    /// If you want to get the value periodically, it is recommended to use the
    /// [`get_temperature_callback_receiver`] receiver. You can set the receiver configuration
    /// with `Set Temperature Receiver Configuration`.
    ///
    /// [`get_temperature_callback_receiver`]: #method.get_temperature_callback_receiver
    pub fn get_temperature(&self) -> ConvertingReceiver<i32> {
        let payload = vec![0; 0];

        self.device.get(u8::from(PtcV2BrickletFunction::GetTemperature), payload)
    }

    /// The period in ms is the period with which the [`get_temperature_callback_receiver`] receiver is triggered
    /// periodically. A value of 0 turns the receiver off.
    ///
    /// If the `value has to change`-parameter is set to true, the receiver is only
    /// triggered after the value has changed. If the value didn't change
    /// within the period, the receiver is triggered immediately on change.
    ///
    /// If it is set to false, the receiver is continuously triggered with the period,
    /// independent of the value.
    ///
    /// It is furthermore possible to constrain the receiver with thresholds.
    ///
    /// The `option`-parameter together with min/max sets a threshold for the [`get_temperature_callback_receiver`] receiver.
    ///
    /// The following options are possible:
    ///
    ///  Option| Description
    ///  --- | ---
    ///  'x'|    Threshold is turned off
    ///  'o'|    Threshold is triggered when the value is *outside* the min and max values
    ///  'i'|    Threshold is triggered when the value is *inside* or equal to the min and max values
    ///  '<'|    Threshold is triggered when the value is smaller than the min value (max is ignored)
    ///  '>'|    Threshold is triggered when the value is greater than the min value (max is ignored)
    ///
    /// If the option is set to 'x' (threshold turned off) the receiver is triggered with the fixed period.
    ///
    /// The default value is (0, false, 'x', 0, 0).
    ///
    /// [`get_temperature_callback_receiver`]: #method.get_temperature_callback_receiver
    ///
    /// Associated constants:
    /// * PTC_V2BRICKLET_THRESHOLD_OPTION_OFF
    ///	* PTC_V2BRICKLET_THRESHOLD_OPTION_OUTSIDE
    ///	* PTC_V2BRICKLET_THRESHOLD_OPTION_INSIDE
    ///	* PTC_V2BRICKLET_THRESHOLD_OPTION_SMALLER
    ///	* PTC_V2BRICKLET_THRESHOLD_OPTION_GREATER
    pub fn set_temperature_callback_configuration(
        &self,
        period: u32,
        value_has_to_change: bool,
        option: char,
        min: i32,
        max: i32,
    ) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 14];
        payload[0..4].copy_from_slice(&<u32>::to_le_bytes(period));
        payload[4..5].copy_from_slice(&<bool>::to_le_bytes(value_has_to_change));
        payload[5..6].copy_from_slice(&<char>::to_le_bytes(option));
        payload[6..10].copy_from_slice(&<i32>::to_le_bytes(min));
        payload[10..14].copy_from_slice(&<i32>::to_le_bytes(max));

        self.device.set(u8::from(PtcV2BrickletFunction::SetTemperatureCallbackConfiguration), payload)
    }

    /// Returns the receiver configuration as set by `Set Temperature Receiver Configuration`.
    ///
    /// Associated constants:
    /// * PTC_V2BRICKLET_THRESHOLD_OPTION_OFF
    ///	* PTC_V2BRICKLET_THRESHOLD_OPTION_OUTSIDE
    ///	* PTC_V2BRICKLET_THRESHOLD_OPTION_INSIDE
    ///	* PTC_V2BRICKLET_THRESHOLD_OPTION_SMALLER
    ///	* PTC_V2BRICKLET_THRESHOLD_OPTION_GREATER
    pub fn get_temperature_callback_configuration(&self) -> ConvertingReceiver<TemperatureCallbackConfiguration> {
        let payload = vec![0; 0];

        self.device.get(u8::from(PtcV2BrickletFunction::GetTemperatureCallbackConfiguration), payload)
    }

    /// Returns the value as measured by the MAX31865 precision delta-sigma ADC.
    ///
    /// The value can be converted with the following formulas:
    ///
    /// * Pt100:  resistance = (value * 390) / 32768
    /// * Pt1000: resistance = (value * 3900) / 32768
    ///
    ///
    /// If you want to get the value periodically, it is recommended to use the
    /// [`get_resistance_callback_receiver`] receiver. You can set the receiver configuration
    /// with `Set Resistance Receiver Configuration`.
    ///
    /// [`get_resistance_callback_receiver`]: #method.get_resistance_callback_receiver
    pub fn get_resistance(&self) -> ConvertingReceiver<i32> {
        let payload = vec![0; 0];

        self.device.get(u8::from(PtcV2BrickletFunction::GetResistance), payload)
    }

    /// The period in ms is the period with which the [`get_resistance_callback_receiver`] receiver is triggered
    /// periodically. A value of 0 turns the receiver off.
    ///
    /// If the `value has to change`-parameter is set to true, the receiver is only
    /// triggered after the value has changed. If the value didn't change
    /// within the period, the receiver is triggered immediately on change.
    ///
    /// If it is set to false, the receiver is continuously triggered with the period,
    /// independent of the value.
    ///
    /// It is furthermore possible to constrain the receiver with thresholds.
    ///
    /// The `option`-parameter together with min/max sets a threshold for the [`get_resistance_callback_receiver`] receiver.
    ///
    /// The following options are possible:
    ///
    ///  Option| Description
    ///  --- | ---
    ///  'x'|    Threshold is turned off
    ///  'o'|    Threshold is triggered when the value is *outside* the min and max values
    ///  'i'|    Threshold is triggered when the value is *inside* or equal to the min and max values
    ///  '<'|    Threshold is triggered when the value is smaller than the min value (max is ignored)
    ///  '>'|    Threshold is triggered when the value is greater than the min value (max is ignored)
    ///
    /// If the option is set to 'x' (threshold turned off) the receiver is triggered with the fixed period.
    ///
    /// The default value is (0, false, 'x', 0, 0).
    ///
    /// [`get_resistance_callback_receiver`]: #method.get_resistance_callback_receiver
    ///
    /// Associated constants:
    /// * PTC_V2BRICKLET_THRESHOLD_OPTION_OFF
    ///	* PTC_V2BRICKLET_THRESHOLD_OPTION_OUTSIDE
    ///	* PTC_V2BRICKLET_THRESHOLD_OPTION_INSIDE
    ///	* PTC_V2BRICKLET_THRESHOLD_OPTION_SMALLER
    ///	* PTC_V2BRICKLET_THRESHOLD_OPTION_GREATER
    pub fn set_resistance_callback_configuration(
        &self,
        period: u32,
        value_has_to_change: bool,
        option: char,
        min: i32,
        max: i32,
    ) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 14];
        payload[0..4].copy_from_slice(&<u32>::to_le_bytes(period));
        payload[4..5].copy_from_slice(&<bool>::to_le_bytes(value_has_to_change));
        payload[5..6].copy_from_slice(&<char>::to_le_bytes(option));
        payload[6..10].copy_from_slice(&<i32>::to_le_bytes(min));
        payload[10..14].copy_from_slice(&<i32>::to_le_bytes(max));

        self.device.set(u8::from(PtcV2BrickletFunction::SetResistanceCallbackConfiguration), payload)
    }

    /// Returns the receiver configuration as set by `Set Resistance Receiver Configuration`.
    ///
    /// Associated constants:
    /// * PTC_V2BRICKLET_THRESHOLD_OPTION_OFF
    ///	* PTC_V2BRICKLET_THRESHOLD_OPTION_OUTSIDE
    ///	* PTC_V2BRICKLET_THRESHOLD_OPTION_INSIDE
    ///	* PTC_V2BRICKLET_THRESHOLD_OPTION_SMALLER
    ///	* PTC_V2BRICKLET_THRESHOLD_OPTION_GREATER
    pub fn get_resistance_callback_configuration(&self) -> ConvertingReceiver<ResistanceCallbackConfiguration> {
        let payload = vec![0; 0];

        self.device.get(u8::from(PtcV2BrickletFunction::GetResistanceCallbackConfiguration), payload)
    }

    /// Sets the noise rejection filter to either 50Hz (0) or 60Hz (1).
    /// Noise from 50Hz or 60Hz power sources (including
    /// harmonics of the AC power's fundamental frequency) is
    /// attenuated by 82dB.
    ///
    /// Default value is 0 = 50Hz.
    ///
    /// Associated constants:
    /// * PTC_V2BRICKLET_FILTER_OPTION_50HZ
    ///	* PTC_V2BRICKLET_FILTER_OPTION_60HZ
    pub fn set_noise_rejection_filter(&self, filter: u8) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 1];
        payload[0..1].copy_from_slice(&<u8>::to_le_bytes(filter));

        self.device.set(u8::from(PtcV2BrickletFunction::SetNoiseRejectionFilter), payload)
    }

    /// Returns the noise rejection filter option as set by
    /// `Set Noise Rejection Filter`
    ///
    /// Associated constants:
    /// * PTC_V2BRICKLET_FILTER_OPTION_50HZ
    ///	* PTC_V2BRICKLET_FILTER_OPTION_60HZ
    pub fn get_noise_rejection_filter(&self) -> ConvertingReceiver<u8> {
        let payload = vec![0; 0];

        self.device.get(u8::from(PtcV2BrickletFunction::GetNoiseRejectionFilter), payload)
    }

    /// Returns *true* if the sensor is connected correctly.
    ///
    /// If this function
    /// returns *false*, there is either no Pt100 or Pt1000 sensor connected,
    /// the sensor is connected incorrectly or the sensor itself is faulty.
    ///
    /// If you want to get the status automatically, it is recommended to use the
    /// [`get_sensor_connected_callback_receiver`] receiver. You can set the receiver configuration
    /// with `Set Sensor Connected Receiver Configuration`.
    ///
    /// [`get_sensor_connected_callback_receiver`]: #method.get_sensor_connected_callback_receiver
    pub fn is_sensor_connected(&self) -> ConvertingReceiver<bool> {
        let payload = vec![0; 0];

        self.device.get(u8::from(PtcV2BrickletFunction::IsSensorConnected), payload)
    }

    /// Sets the wire mode of the sensor. Possible values are 2, 3 and 4 which
    /// correspond to 2-, 3- and 4-wire sensors. The value has to match the jumper
    /// configuration on the Bricklet.
    ///
    /// The default value is 2 = 2-wire.
    ///
    /// Associated constants:
    /// * PTC_V2BRICKLET_WIRE_MODE_2
    ///	* PTC_V2BRICKLET_WIRE_MODE_3
    ///	* PTC_V2BRICKLET_WIRE_MODE_4
    pub fn set_wire_mode(&self, mode: u8) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 1];
        payload[0..1].copy_from_slice(&<u8>::to_le_bytes(mode));

        self.device.set(u8::from(PtcV2BrickletFunction::SetWireMode), payload)
    }

    /// Returns the wire mode as set by `Set Wire Mode`
    ///
    /// Associated constants:
    /// * PTC_V2BRICKLET_WIRE_MODE_2
    ///	* PTC_V2BRICKLET_WIRE_MODE_3
    ///	* PTC_V2BRICKLET_WIRE_MODE_4
    pub fn get_wire_mode(&self) -> ConvertingReceiver<u8> {
        let payload = vec![0; 0];

        self.device.get(u8::from(PtcV2BrickletFunction::GetWireMode), payload)
    }

    /// Sets the length of a [moving averaging](https://en.wikipedia.org/wiki/Moving_average)__
    /// for the resistance and temperature.
    ///
    /// Setting the length to 1 will turn the averaging off. With less
    /// averaging, there is more noise on the data.
    ///
    /// The range for the averaging is 1-1000.
    ///
    /// New data is gathered every 20ms. With a moving average of length 1000 the resulting
    /// averaging window has a length of 20s. If you want to do long term measurements the longest
    /// moving average will give the cleanest results.
    ///
    /// The default value is 1 for resistance and 40 for temperature. The default values match
    /// the non-changeable averaging settings of the old PTC Bricklet 1.0
    pub fn set_moving_average_configuration(
        &self,
        moving_average_length_resistance: u16,
        moving_average_length_temperature: u16,
    ) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 4];
        payload[0..2].copy_from_slice(&<u16>::to_le_bytes(moving_average_length_resistance));
        payload[2..4].copy_from_slice(&<u16>::to_le_bytes(moving_average_length_temperature));

        self.device.set(u8::from(PtcV2BrickletFunction::SetMovingAverageConfiguration), payload)
    }

    /// Returns the moving average configuration as set by `Set Moving Average Configuration`.
    pub fn get_moving_average_configuration(&self) -> ConvertingReceiver<MovingAverageConfiguration> {
        let payload = vec![0; 0];

        self.device.get(u8::from(PtcV2BrickletFunction::GetMovingAverageConfiguration), payload)
    }

    /// If you enable this receiver, the [`get_sensor_connected_callback_receiver`] receiver is triggered
    /// every time a Pt sensor is connected/disconnected.
    ///
    /// By default this receiver is disabled.
    ///
    /// [`get_sensor_connected_callback_receiver`]: #method.get_sensor_connected_callback_receiver
    pub fn set_sensor_connected_callback_configuration(&self, enabled: bool) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 1];
        payload[0..1].copy_from_slice(&<bool>::to_le_bytes(enabled));

        self.device.set(u8::from(PtcV2BrickletFunction::SetSensorConnectedCallbackConfiguration), payload)
    }

    /// Returns the configuration as set by `Set Sensor Connected Receiver Configuration`.
    pub fn get_sensor_connected_callback_configuration(&self) -> ConvertingReceiver<bool> {
        let payload = vec![0; 0];

        self.device.get(u8::from(PtcV2BrickletFunction::GetSensorConnectedCallbackConfiguration), payload)
    }

    /// Returns the error count for the communication between Brick and Bricklet.
    ///
    /// The errors are divided into
    ///
    /// * ACK checksum errors,
    /// * message checksum errors,
    /// * framing errors and
    /// * overflow errors.
    ///
    /// The errors counts are for errors that occur on the Bricklet side. All
    /// Bricks have a similar function that returns the errors on the Brick side.
    pub fn get_spitfp_error_count(&self) -> ConvertingReceiver<SpitfpErrorCount> {
        let payload = vec![0; 0];

        self.device.get(u8::from(PtcV2BrickletFunction::GetSpitfpErrorCount), payload)
    }

    /// Sets the bootloader mode and returns the status after the requested
    /// mode change was instigated.
    ///
    /// You can change from bootloader mode to firmware mode and vice versa. A change
    /// from bootloader mode to firmware mode will only take place if the entry function,
    /// device identifier and CRC are present and correct.
    ///
    /// This function is used by Brick Viewer during flashing. It should not be
    /// necessary to call it in a normal user program.
    ///
    /// Associated constants:
    /// * PTC_V2BRICKLET_BOOTLOADER_MODE_BOOTLOADER
    ///	* PTC_V2BRICKLET_BOOTLOADER_MODE_FIRMWARE
    ///	* PTC_V2BRICKLET_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT
    ///	* PTC_V2BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT
    ///	* PTC_V2BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT
    ///	* PTC_V2BRICKLET_BOOTLOADER_STATUS_OK
    ///	* PTC_V2BRICKLET_BOOTLOADER_STATUS_INVALID_MODE
    ///	* PTC_V2BRICKLET_BOOTLOADER_STATUS_NO_CHANGE
    ///	* PTC_V2BRICKLET_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT
    ///	* PTC_V2BRICKLET_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT
    ///	* PTC_V2BRICKLET_BOOTLOADER_STATUS_CRC_MISMATCH
    pub fn set_bootloader_mode(&self, mode: u8) -> ConvertingReceiver<u8> {
        let mut payload = vec![0; 1];
        payload[0..1].copy_from_slice(&<u8>::to_le_bytes(mode));

        self.device.get(u8::from(PtcV2BrickletFunction::SetBootloaderMode), payload)
    }

    /// Returns the current bootloader mode, see `Set Bootloader Mode`.
    ///
    /// Associated constants:
    /// * PTC_V2BRICKLET_BOOTLOADER_MODE_BOOTLOADER
    ///	* PTC_V2BRICKLET_BOOTLOADER_MODE_FIRMWARE
    ///	* PTC_V2BRICKLET_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT
    ///	* PTC_V2BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT
    ///	* PTC_V2BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT
    pub fn get_bootloader_mode(&self) -> ConvertingReceiver<u8> {
        let payload = vec![0; 0];

        self.device.get(u8::from(PtcV2BrickletFunction::GetBootloaderMode), payload)
    }

    /// Sets the firmware pointer for `Write Firmware`. The pointer has
    /// to be increased by chunks of size 64. The data is written to flash
    /// every 4 chunks (which equals to one page of size 256).
    ///
    /// This function is used by Brick Viewer during flashing. It should not be
    /// necessary to call it in a normal user program.
    pub fn set_write_firmware_pointer(&self, pointer: u32) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 4];
        payload[0..4].copy_from_slice(&<u32>::to_le_bytes(pointer));

        self.device.set(u8::from(PtcV2BrickletFunction::SetWriteFirmwarePointer), payload)
    }

    /// Writes 64 Bytes of firmware at the position as written by
    /// `Set Write Firmware Pointer` before. The firmware is written
    /// to flash every 4 chunks.
    ///
    /// You can only write firmware in bootloader mode.
    ///
    /// This function is used by Brick Viewer during flashing. It should not be
    /// necessary to call it in a normal user program.
    pub fn write_firmware(&self, data: [u8; 64]) -> ConvertingReceiver<u8> {
        let mut payload = vec![0; 64];
        payload[0..64].copy_from_slice(&<[u8; 64]>::to_le_bytes(data));

        self.device.get(u8::from(PtcV2BrickletFunction::WriteFirmware), payload)
    }

    /// Sets the status LED configuration. By default the LED shows
    /// communication traffic between Brick and Bricklet, it flickers once
    /// for every 10 received data packets.
    ///
    /// You can also turn the LED permanently on/off or show a heartbeat.
    ///
    /// If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    ///
    /// Associated constants:
    /// * PTC_V2BRICKLET_STATUS_LED_CONFIG_OFF
    ///	* PTC_V2BRICKLET_STATUS_LED_CONFIG_ON
    ///	* PTC_V2BRICKLET_STATUS_LED_CONFIG_SHOW_HEARTBEAT
    ///	* PTC_V2BRICKLET_STATUS_LED_CONFIG_SHOW_STATUS
    pub fn set_status_led_config(&self, config: u8) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 1];
        payload[0..1].copy_from_slice(&<u8>::to_le_bytes(config));

        self.device.set(u8::from(PtcV2BrickletFunction::SetStatusLedConfig), payload)
    }

    /// Returns the configuration as set by `Set Status LED Config`
    ///
    /// Associated constants:
    /// * PTC_V2BRICKLET_STATUS_LED_CONFIG_OFF
    ///	* PTC_V2BRICKLET_STATUS_LED_CONFIG_ON
    ///	* PTC_V2BRICKLET_STATUS_LED_CONFIG_SHOW_HEARTBEAT
    ///	* PTC_V2BRICKLET_STATUS_LED_CONFIG_SHOW_STATUS
    pub fn get_status_led_config(&self) -> ConvertingReceiver<u8> {
        let payload = vec![0; 0];

        self.device.get(u8::from(PtcV2BrickletFunction::GetStatusLedConfig), payload)
    }

    /// Returns the temperature in °C as measured inside the microcontroller. The
    /// value returned is not the ambient temperature!
    ///
    /// The temperature is only proportional to the real temperature and it has bad
    /// accuracy. Practically it is only useful as an indicator for
    /// temperature changes.
    pub fn get_chip_temperature(&self) -> ConvertingReceiver<i16> {
        let payload = vec![0; 0];

        self.device.get(u8::from(PtcV2BrickletFunction::GetChipTemperature), payload)
    }

    /// Calling this function will reset the Bricklet. All configurations
    /// will be lost.
    ///
    /// After a reset you have to create new device objects,
    /// calling functions on the existing ones will result in
    /// undefined behavior!
    pub fn reset(&self) -> ConvertingReceiver<()> {
        let payload = vec![0; 0];

        self.device.set(u8::from(PtcV2BrickletFunction::Reset), payload)
    }

    /// Writes a new UID into flash. If you want to set a new UID
    /// you have to decode the Base58 encoded UID string into an
    /// integer first.
    ///
    /// We recommend that you use Brick Viewer to change the UID.
    pub fn write_uid(&self, uid: u32) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 4];
        payload[0..4].copy_from_slice(&<u32>::to_le_bytes(uid));

        self.device.set(u8::from(PtcV2BrickletFunction::WriteUid), payload)
    }

    /// Returns the current UID as an integer. Encode as
    /// Base58 to get the usual string version.
    pub fn read_uid(&self) -> ConvertingReceiver<u32> {
        let payload = vec![0; 0];

        self.device.get(u8::from(PtcV2BrickletFunction::ReadUid), payload)
    }

    /// Returns the UID, the UID where the Bricklet is connected to,
    /// the position, the hardware and firmware version as well as the
    /// device identifier.
    ///
    /// The position can be 'a', 'b', 'c' or 'd'.
    ///
    /// The device identifier numbers can be found [here](device_identifier).
    /// |device_identifier_constant|
    pub fn get_identity(&self) -> ConvertingReceiver<Identity> {
        let payload = vec![0; 0];

        self.device.get(u8::from(PtcV2BrickletFunction::GetIdentity), payload)
    }
}
